#All big rooms

execute as @e[name=Room,tag=RoomBig,limit=10] at @s unless block ~3 7 ~2 air run function ruins:room3x
execute as @e[name=Room,tag=RoomBig,limit=10] at @s unless block ~-2 7 ~-3 air run function ruins:room3z

#All normal rooms
execute as @e[name=Room,tag=!RoomDone] at @s run function ruins:room2

#All bonus rooms
execute as @e[name=Room,tag=RoomSmall,scores={Count=1},tag=!BossRoom,tag=!StartRoom] at @s run function ruins:room4

#All giant rooms
execute as @e[name=Room,tag=RoomSmall,scores={Count=4}] at @s unless entity @e[tag=StartRoom,distance=..10] unless entity @e[tag=BossRoom,distance=..10] positioned ~7 ~ ~ if entity @e[distance=..2,name=Room] positioned ~ ~ ~7 if entity @e[distance=..2,name=Room] positioned ~-7 ~ ~ if entity @e[distance=..2,name=Room] run tag @s add Giant
execute as @e[name=Room,tag=Giant,limit=1,sort=random] at @s run function ruins:room5

#Start/Boss rooms
execute as @e[name=Room,tag=StartRoom] at @s run function ruins:room6a
execute as @e[name=Room,tag=BossRoom] at @s run function ruins:room6b

#Extra void placement
execute at @e[name=Room] unless block ~3 7 ~ air run fill ~7 8 ~ ~ 9 ~ structure_void replace air
execute at @e[name=Room] unless block ~-3 7 ~ air run fill ~-7 8 ~ ~ 9 ~ structure_void replace air
execute at @e[name=Room] unless block ~ 7 ~3 air run fill ~ 8 ~7 ~ 9 ~ structure_void replace air
execute at @e[name=Room] unless block ~ 7 ~-3 air run fill ~ 8 ~-7 ~ 9 ~ structure_void replace air

#Wall placement
execute at @e[name=Room,tag=BossRoom] run fill ~4 8 ~4 ~-4 9 ~-4 chiseled_quartz_block replace air
execute at @e[name=Room,tag=Secret6] run fill ~4 7 ~4 ~-4 9 ~-4 black_concrete replace air
execute at @e[name=Room,limit=9,sort=random] positioned ~ 7 ~ run fill ~3 ~1 ~3 ~-3 ~2 ~-3 purpur_pillar replace air
execute at @e[name=Room,limit=9,sort=random] positioned ~ 7 ~ run fill ~3 ~1 ~3 ~-3 ~2 ~-3 magenta_stained_glass replace air
execute at @e[name=Room,limit=9,sort=random] positioned ~ 7 ~ run fill ~3 ~2 ~3 ~-3 ~2 ~-3 purpur_slab replace air
execute at @e[name=Room,limit=6,sort=random] positioned ~ 7 ~ run fill ~3 ~1 ~3 ~-3 ~2 ~-3 purple_stained_glass replace air
execute at @e[name=Room] positioned ~ 7 ~ run fill ~3 ~1 ~3 ~-3 ~2 ~-3 purpur_block replace air
execute at @e[name=Room,tag=BossRoom] unless block ~4 7 ~ purpur_block run fill ~4 8 ~ ~4 9 ~ chiseled_quartz_block
execute at @e[name=Room,tag=BossRoom] unless block ~-4 7 ~ purpur_block run fill ~-4 8 ~ ~-4 9 ~ chiseled_quartz_block
execute at @e[name=Room,tag=BossRoom] unless block ~ 7 ~4 purpur_block run fill ~ 8 ~4 ~ 9 ~4 chiseled_quartz_block
execute at @e[name=Room,tag=BossRoom] unless block ~ 7 ~-4 purpur_block run fill ~ 8 ~-4 ~ 9 ~-4 chiseled_quartz_block
execute at @e[name=Room,tag=BossRoom] if block ~4 7 ~ purpur_block run setblock ~4 7 ~ red_nether_bricks
execute at @e[name=Room,tag=BossRoom] if block ~-4 7 ~ purpur_block run setblock ~-4 7 ~ red_nether_bricks
execute at @e[name=Room,tag=BossRoom] if block ~ 7 ~4 purpur_block run setblock ~ 7 ~4 red_nether_bricks
execute at @e[name=Room,tag=BossRoom] if block ~ 7 ~-4 purpur_block run setblock ~ 7 ~-4 red_nether_bricks

#Bonus rooms
execute as @e[name=Room,tag=!StartRoom,tag=!BossRoom,limit=4,sort=random] at @s unless block ~ 7 ~ #path:use run function ruins:room7
execute at @e[name=Room,tag=Secret6] run clone -46 32 48 -52 35 54 ~-3 7 ~-3

#Craft and Smite room
execute as @e[name=Room,sort=random,limit=1,tag=RoomSmall,scores={Count=2..},tag=!StartRoom,tag=!BossRoom,tag=!Secret1] run tag @s add Craft
execute at @e[name=Room,tag=Craft] run clone -29 7 28 -25 9 32 ~-2 7 ~-2

execute as @e[name=Room,sort=random,limit=1,tag=RoomSmall,scores={Count=2..},tag=!StartRoom,tag=!BossRoom,tag=!Craft,tag=!Secret1] run tag @s add Smite
execute at @e[tag=Smite] run clone -29 7 34 -25 9 38 ~-2 7 ~-2

execute at @e[tag=Craft] run fill ~-2 7 ~-2 ~2 7 ~2 purpur_block replace dirt
execute at @e[tag=Smite] run fill ~-2 7 ~-2 ~2 7 ~2 purpur_block replace iron_block